#ifndef _INIT_INCLUDED_
#define _INIT_INCLUDED_
/*
 *  init.h
 *  Zde jsou ruzne fce pro inicializovani OS,
 *  ktere se provedou hned po bootovani 
 */

#include <global.h>
#include <malloc.h>
#include <printf.h>
#include <string.h>
#include <video.h>

void iRslt(int vysledek) {
  if(vysledek == 0) {
    textcolor(LIGHTGRAY);
    printf("[");
    textcolor(LIGHTGREEN);
    printf("  OK  ");
    textcolor(LIGHTGRAY);
    printf("]\r\n");
    return;
  }
  if(vysledek == 1) {
    textcolor(LIGHTGRAY);
    printf("[");
    textcolor(LIGHTRED);
    printf("ERROR!");
    textcolor(LIGHTGRAY);
    printf("]\r\n");
    return;
  }
  if(vysledek == 2) {
    textcolor(LIGHTGRAY);
    printf("[");
    textcolor(LIGHTRED);
    printf(" WARN ");
    textcolor(LIGHTGRAY);
    printf("]\r\n");
    return;
  }
    textcolor(LIGHTGRAY);
    printf("[");
    textcolor(LIGHTRED);
    printf("UNKNWN");
    textcolor(LIGHTGRAY);
    printf("]\r\n");
    return;
}

/*
 *  iBootLoader()
 *  nacte boot record do globalni promenne <mbr>
 */ 
/* 
BootRecord *mbr;
unsigned int RootDirSect = 0;
unsigned int FATSectors  = 0;
unsigned int DataStart   = 0;
*/
int iBootLoader(void) {
  mbr = malloc(sizeof(BootRecord));
  readdisk(1, 1, mbr);
  
	RootDirSect           = (((mbr->root_size*32)+(mbr->sector_size-1))/mbr->sector_size); /* vypocitej kolik sektoru ma root*/
	FATSectors	          = mbr->fat_count*mbr->fat_size16;	                               /* kolik ma fat sektoru   */
	DataStart	            = mbr->sector_reserved+FATSectors+RootDirSect;                   /* zacatek dat    */
  StartSector           = (DataStart+1);
  return 0;
}


void init(void) {
gotoxy(0,0);
  printf("%59s"," _____ _ _       _        _____ _____ \r\n");
  printf("%59s","|  _  | | |_ ___|_|___   |     |   __|\r\n");
  printf("%59s","|     | |  _| .'| |  _|  |  |  |__   |\r\n");
  printf("%59s","|__|__|_|_| |__,|_|_|    |_____|_____|\r\n");
gotoxy(6,14);
  printf(              "............................ ");
    iRslt(0);
  printf("Zjistuji nastaveni diskety ............... ");    
    iRslt(iBootLoader());
  printf("Startuji SHELL...\r\n\n");
  
  return;
}
#endif
